module Tardef::Connector
  class Base
    @filename = ""
    attr_accessor :filename  

    def read
      hash = read_file
      file = Tardef::File.new(nil, nil, nil)
      file.load_hash(hash["meta"])
      file.filename = @filename

      list, tag, task = Tardef::List, Tardef::Tag, Tardef::Task
      extension       = Tardef::Extension
      entries = {"lists" => list, "tags" => tag, "tasks" => task,
                 "extensions" => extension}
      
      entries.map do |key, value|
        next unless hash[key]
        hash[key].each do |hsh|
          entry = value.new("", "", "")
          entry.load_hash(hsh)
          file << entry
        end
      end
      
      file.schema = hash["schema"] if hash["schema"]
      file
    end

    def write(file_object)
      hash = file_object.to_hash
      write_file(hash)
    end

    def set_filename(filename)
      @filename = filename
    end

    def initialize(filename)
      @filename = filename
    end
  end
end
