module Tardef
  class Object < Base
    attr_accessor :uid, :title, :description
  end

  class List < Object
    attr_accessor :parent
  
    def initialize(uid, title, description = "", parent = "", extensions = [])
      @uid, @title, @description, @parent = uid, title, description, parent
      @extensions = extensions
    end
  end

  class Tag < List
  end

  class Task < Object
    attr_accessor :created_at, :changed_at, :done_at, :due_at
    attr_accessor :hidden, :list, :tags
  
    def initialize(uid, title, created_at, description = "", changed_at = "", done_at = "", due_at = "", hidden = false, list = "", tags = [])
      super()
      @uid, @title, @description, @list = uid, title, description, list
      @changed_at, @created_at, @done_at = changed_at, created_at, done_at
      @due_at, @hidden, @tags = due_at, hidden, tags
    end
  end
  
  class Extension < Base
    attr_accessor :name, :data
    
    def initialize(name, schema)
      @name, @data = name, data
    end
  end
end