module Tardef::Validator
  class Base
    def initialize
      @errors = []
    end
  end
  
  class Chain
    def initialize
      @validators = []
      @errors = []
    end
    
    def add_validator(validator)
      @validators << validator
    end
    
    def validate(file_obj)
      @errors = []
      @validators.each do |validator|
        @errors += validator.validate(file_obj)
      end
      @errors
    end
    
    def get_errors
      @errors
    end
    
    def is_valid?
      !@errors.empty?
    end
  end
end