module Tardef::Validator
  class Links < Base
    def initialize
      super
    end
    
    def validate(file_obj)
      file_obj.lists.each do |list|
        parent = list.parent
        if parent and not parent.empty? and not file_obj.has_list?(parent)
          @errors << "List parent #{parent} does not exist"
        end
      end

      file_obj.tags.each do |tag|
        parent = tag.parent
        if parent and not parent.empty? and not file_obj.has_tag?(parent)
          @errors << "Tag parent #{parent} does not exist"
        end
      end

      file_obj.tasks.each do |task|
        parent = task.list
        if parent and not parent.empty? and not file_obj.has_list?(parent)
          @errors << "Task list #{parent} does not exist"
        end
        task.tags.each do |tag|
          @errors << "Tag #{tag} does not exist" unless file_obj.has_tag?(tag)
        end
      end
      @errors
    end
  end
end