require "json"
require "yaml"
require "kwalify"
require "open-uri"

module Tardef::Validator
  class Syntax < Base
    def initialize(schema_path)
      super()
      @schema_path = schema_path
    end
    
    def validate(obj)
      schema = ::YAML.load(open(@schema_path))
      data = obj.to_hash
      validator = Kwalify::Validator.new(schema)
      errors = validator.validate(data)
      
      if (errors && !errors.empty?)
        for e in errors
          @errors << "Schema error: [#{e.path}] #{e.message}"
        end
      end
      @errors
    end
  end
end